org.wildfly.swarm.config.datasources

## Class DataSource<T extends DataSource<T>>

- java.lang.Object
- - org.wildfly.swarm.config.datasources.DataSource<T>

-     public class DataSource<T extends DataSource<T>>
      extends Object

  A JDBC data-source configuration

- - ### Property Summary

    All Methods Instance Methods Concrete Methods
    Type | Property and Description
    --- | ---
    `Map` | `connectionListener` Properties to be injected in class specidied in connection-listener-class

  - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `DataSource.DataSourceResources` Child mutators for DataSource

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DataSource(String key)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addPropertyChangeListener(PropertyChangeListener listener)` Adds a property change listener
    `Integer` | `allocationRetry()` The allocation retry element indicates the number of times that allocating a connection should be tried before throwing an exception
    `T` | `allocationRetry(Integer value)` The allocation retry element indicates the number of times that allocating a connection should be tried before throwing an exception
    `Long` | `allocationRetryWaitMillis()` The allocation retry wait millis element specifies the amount of time, in milliseconds, to wait between retrying to allocate a connection
    `T` | `allocationRetryWaitMillis(Long value)` The allocation retry wait millis element specifies the amount of time, in milliseconds, to wait between retrying to allocate a connection
    `Boolean` | `allowMultipleUsers()` Specifies if multiple users will access the datasource through the getConnection(user, password) method and hence if the internal pool type should account for that
    `T` | `allowMultipleUsers(Boolean value)` Specifies if multiple users will access the datasource through the getConnection(user, password) method and hence if the internal pool type should account for that
    `String` | `authenticationContext()` The Elytron authentication context which defines the javax.security.auth.Subject that is used to distinguish connections in the pool.
    `T` | `authenticationContext(String value)` The Elytron authentication context which defines the javax.security.auth.Subject that is used to distinguish connections in the pool.
    `Boolean` | `backgroundValidation()` An element to specify that connections should be validated on a background thread versus being validated prior to use.
    `T` | `backgroundValidation(Boolean value)` An element to specify that connections should be validated on a background thread versus being validated prior to use.
    `Long` | `backgroundValidationMillis()` The background-validation-millis element specifies the amount of time, in milliseconds, that background validation will run.
    `T` | `backgroundValidationMillis(Long value)` The background-validation-millis element specifies the amount of time, in milliseconds, that background validation will run.
    `Long` | `blockingTimeoutWaitMillis()` The blocking-timeout-millis element specifies the maximum time, in milliseconds, to block while waiting for a connection before throwing an exception.
    `T` | `blockingTimeoutWaitMillis(Long value)` The blocking-timeout-millis element specifies the maximum time, in milliseconds, to block while waiting for a connection before throwing an exception.
    `String` | `capacityDecrementerClass()` Class defining the policy for decrementing connections in the pool
    `T` | `capacityDecrementerClass(String value)` Class defining the policy for decrementing connections in the pool
    `Map` | `capacityDecrementerProperties()` Properties to be injected in class defining the policy for decrementing connections in the pool
    `T` | `capacityDecrementerProperties(Map value)` Properties to be injected in class defining the policy for decrementing connections in the pool
    `T` | `capacityDecrementerProperty(String key, Object value)` Properties to be injected in class defining the policy for decrementing connections in the pool
    `String` | `capacityIncrementerClass()` Class defining the policy for incrementing connections in the pool
    `T` | `capacityIncrementerClass(String value)` Class defining the policy for incrementing connections in the pool
    `Map` | `capacityIncrementerProperties()` Properties to be injected in class defining the policy for incrementing connections in the pool
    `T` | `capacityIncrementerProperties(Map value)` Properties to be injected in class defining the policy for incrementing connections in the pool
    `T` | `capacityIncrementerProperty(String key, Object value)` Properties to be injected in class defining the policy for incrementing connections in the pool
    `String` | `checkValidConnectionSql()` Specify an SQL statement to check validity of a pool connection.
    `T` | `checkValidConnectionSql(String value)` Specify an SQL statement to check validity of a pool connection.
    `Boolean` | `connectable()` Enable the use of CMR.
    `T` | `connectable(Boolean value)` Enable the use of CMR.
    `String` | `connectionListenerClass()` Speciefies class name extending org.jboss.jca.adapters.jdbc.spi.listener.ConnectionListener that provides a possible to listen for connection activation and passivation in order to perform actions before the connection is returned to the application or returned to the pool.
    `T` | `connectionListenerClass(String value)` Speciefies class name extending org.jboss.jca.adapters.jdbc.spi.listener.ConnectionListener that provides a possible to listen for connection activation and passivation in order to perform actions before the connection is returned to the application or returned to the pool.
    `Map` | `connectionListenerProperty()` Properties to be injected in class specidied in connection-listener-class
    `T` | `connectionListenerProperty(Map value)` Properties to be injected in class specidied in connection-listener-class
    `T` | `connectionListenerProperty(String key, Object value)` Properties to be injected in class specidied in connection-listener-class
    `T` | `connectionProperties(ConnectionProperties value)` Add the ConnectionProperties object to the list of subresources
    `T` | `connectionProperties(ConnectionPropertiesSupplier supplier)` Install a supplied ConnectionProperties object to the list of subresources
    `T` | `connectionProperties(List<ConnectionProperties> value)` Add all ConnectionProperties objects to this subresource
    `T` | `connectionProperties(String childKey)` Create and configure a ConnectionProperties object to the list of subresources
    `T` | `connectionProperties(String childKey, ConnectionPropertiesConsumer consumer)` Create and configure a ConnectionProperties object to the list of subresources
    `String` | `connectionUrl()` The JDBC driver connection URL
    `T` | `connectionUrl(String value)` The JDBC driver connection URL
    `Map` | `credentialReference()` Credential (from Credential Store) to authenticate on data source
    `T` | `credentialReference(Map value)` Credential (from Credential Store) to authenticate on data source
    `T` | `credentialReference(String key, Object value)` Credential (from Credential Store) to authenticate on data source
    `String` | `datasourceClass()` The fully qualified name of the JDBC datasource class
    `T` | `datasourceClass(String value)` The fully qualified name of the JDBC datasource class
    `String` | `driverClass()` The fully qualified name of the JDBC driver class
    `T` | `driverClass(String value)` The fully qualified name of the JDBC driver class
    `String` | `driverName()` Defines the JDBC driver the datasource should use.
    `T` | `driverName(String value)` Defines the JDBC driver the datasource should use.
    `Boolean` | `elytronEnabled()` Enables Elytron security for handling authentication of connections.
    `T` | `elytronEnabled(Boolean value)` Enables Elytron security for handling authentication of connections.
    `Boolean` | `enlistmentTrace()` Defines if WildFly/IronJacamar should record enlistment traces
    `T` | `enlistmentTrace(Boolean value)` Defines if WildFly/IronJacamar should record enlistment traces
    `String` | `exceptionSorterClassName()` An org.jboss.jca.adapters.jdbc.ExceptionSorter that provides an isExceptionFatal(SQLException) method to validate if an exception should broadcast an error
    `T` | `exceptionSorterClassName(String value)` An org.jboss.jca.adapters.jdbc.ExceptionSorter that provides an isExceptionFatal(SQLException) method to validate if an exception should broadcast an error
    `Map` | `exceptionSorterProperties()` The exception sorter properties
    `T` | `exceptionSorterProperties(Map value)` The exception sorter properties
    `T` | `exceptionSorterProperty(String key, Object value)` The exception sorter properties
    `FlushStrategy` | `flushStrategy()` Specifies how the pool should be flush in case of an error.
    `T` | `flushStrategy(FlushStrategy value)` Specifies how the pool should be flush in case of an error.
    `String` | `getKey()`
    `Long` | `idleTimeoutMinutes()` The idle-timeout-minutes elements specifies the maximum time, in minutes, a connection may be idle before being closed.
    `T` | `idleTimeoutMinutes(Long value)` The idle-timeout-minutes elements specifies the maximum time, in minutes, a connection may be idle before being closed.
    `Integer` | `initialPoolSize()` The initial-pool-size element indicates the initial number of connections a pool should hold.
    `T` | `initialPoolSize(Integer value)` The initial-pool-size element indicates the initial number of connections a pool should hold.
    `String` | `jndiName()` Specifies the JNDI name for the datasource
    `T` | `jndiName(String value)` Specifies the JNDI name for the datasource
    `Boolean` | `jta()` Enable JTA integration
    `T` | `jta(Boolean value)` Enable JTA integration
    `Integer` | `maxPoolSize()` The max-pool-size element specifies the maximum number of connections for a pool.
    `T` | `maxPoolSize(Integer value)` The max-pool-size element specifies the maximum number of connections for a pool.
    `String` | `mcp()` Defines the ManagedConnectionPool implementation, f.ex.
    `T` | `mcp(String value)` Defines the ManagedConnectionPool implementation, f.ex.
    `Integer` | `minPoolSize()` The min-pool-size element specifies the minimum number of connections for a pool
    `T` | `minPoolSize(Integer value)` The min-pool-size element specifies the minimum number of connections for a pool
    `String` | `newConnectionSql()` Specifies an SQL statement to execute whenever a connection is added to the connection pool
    `T` | `newConnectionSql(String value)` Specifies an SQL statement to execute whenever a connection is added to the connection pool
    `String` | `password()` Specifies the password used when creating a new connection
    `T` | `password(String value)` Specifies the password used when creating a new connection
    `Boolean` | `poolFair()` Defines if pool use should be fair
    `T` | `poolFair(Boolean value)` Defines if pool use should be fair
    `Boolean` | `poolPrefill()` Should the pool be prefilled.
    `T` | `poolPrefill(Boolean value)` Should the pool be prefilled.
    `Boolean` | `poolUseStrictMin()` Specifies if the min-pool-size should be considered strictly
    `T` | `poolUseStrictMin(Boolean value)` Specifies if the min-pool-size should be considered strictly
    `Long` | `preparedStatementsCacheSize()` The number of prepared statements per connection in an LRU cache
    `T` | `preparedStatementsCacheSize(Long value)` The number of prepared statements per connection in an LRU cache
    `Long` | `queryTimeout()` Any configured query timeout in seconds.
    `T` | `queryTimeout(Long value)` Any configured query timeout in seconds.
    `String` | `reauthPluginClassName()` The fully qualified class name of the reauthentication plugin implementation
    `T` | `reauthPluginClassName(String value)` The fully qualified class name of the reauthentication plugin implementation
    `Map` | `reauthPluginProperties()` The properties for the reauthentication plugin
    `T` | `reauthPluginProperties(Map value)` The properties for the reauthentication plugin
    `T` | `reauthPluginProperty(String key, Object value)` The properties for the reauthentication plugin
    `void` | `removePropertyChangeListener(PropertyChangeListener listener)` Removes a property change listener
    `String` | `securityDomain()` Specifies the PicketBox security domain which defines the PicketBox javax.security.auth.Subject that are used to distinguish connections in the pool
    `T` | `securityDomain(String value)` Specifies the PicketBox security domain which defines the PicketBox javax.security.auth.Subject that are used to distinguish connections in the pool
    `Boolean` | `setTxQueryTimeout()` Whether to set the query timeout based on the time remaining until transaction timeout.
    `T` | `setTxQueryTimeout(Boolean value)` Whether to set the query timeout based on the time remaining until transaction timeout.
    `Boolean` | `sharePreparedStatements()` Whether to share prepared statements, i.e.
    `T` | `sharePreparedStatements(Boolean value)` Whether to share prepared statements, i.e.
    `Boolean` | `spy()` Enable spying of SQL statements
    `T` | `spy(Boolean value)` Enable spying of SQL statements
    `String` | `staleConnectionCheckerClassName()` An org.jboss.jca.adapters.jdbc.StaleConnectionChecker that provides an isStaleConnection(SQLException) method which if it returns true will wrap the exception in an org.jboss.jca.adapters.jdbc.StaleConnectionException
    `T` | `staleConnectionCheckerClassName(String value)` An org.jboss.jca.adapters.jdbc.StaleConnectionChecker that provides an isStaleConnection(SQLException) method which if it returns true will wrap the exception in an org.jboss.jca.adapters.jdbc.StaleConnectionException
    `Map` | `staleConnectionCheckerProperties()` The stale connection checker properties
    `T` | `staleConnectionCheckerProperties(Map value)` The stale connection checker properties
    `T` | `staleConnectionCheckerProperty(String key, Object value)` The stale connection checker properties
    `Boolean` | `statisticsEnabled()` Define whether runtime statistics are enabled or not.
    `T` | `statisticsEnabled(Boolean value)` Define whether runtime statistics are enabled or not.
    `DataSource.DataSourceResources` | `subresources()`
    `Boolean` | `tracking()` Defines if IronJacamar should track connection handles across transaction boundaries
    `T` | `tracking(Boolean value)` Defines if IronJacamar should track connection handles across transaction boundaries
    `String` | `trackStatements()` Whether to check for unclosed statements when a connection is returned to the pool, result sets are closed, a statement is closed or return to the prepared statement cache.
    `T` | `trackStatements(String value)` Whether to check for unclosed statements when a connection is returned to the pool, result sets are closed, a statement is closed or return to the prepared statement cache.
    `String` | `transactionIsolation()` Set the java.sql.Connection transaction isolation level.
    `T` | `transactionIsolation(String value)` Set the java.sql.Connection transaction isolation level.
    `String` | `urlDelimiter()` Specifies the delimiter for URLs in connection-url for HA datasources
    `T` | `urlDelimiter(String value)` Specifies the delimiter for URLs in connection-url for HA datasources
    `String` | `urlSelectorStrategyClassName()` A class that implements org.jboss.jca.adapters.jdbc.URLSelectorStrategy
    `T` | `urlSelectorStrategyClassName(String value)` A class that implements org.jboss.jca.adapters.jdbc.URLSelectorStrategy
    `Boolean` | `useCcm()` Enable the use of a cached connection manager
    `T` | `useCcm(Boolean value)` Enable the use of a cached connection manager
    `Boolean` | `useFastFail()` Whether to fail a connection allocation on the first try if it is invalid (true) or keep trying until the pool is exhausted of all potential connections (false)
    `T` | `useFastFail(Boolean value)` Whether to fail a connection allocation on the first try if it is invalid (true) or keep trying until the pool is exhausted of all potential connections (false)
    `Boolean` | `useJavaContext()` Setting this to false will bind the datasource into global JNDI
    `T` | `useJavaContext(Boolean value)` Setting this to false will bind the datasource into global JNDI
    `String` | `userName()` Specify the user name used when creating a new connection
    `T` | `userName(String value)` Specify the user name used when creating a new connection
    `Long` | `useTryLock()` Any configured timeout for internal locks on the resource adapter objects in seconds
    `T` | `useTryLock(Long value)` Any configured timeout for internal locks on the resource adapter objects in seconds
    `Boolean` | `validateOnMatch()` The validate-on-match element specifies if connection validation should be done when a connection factory attempts to match a managed connection.
    `T` | `validateOnMatch(Boolean value)` The validate-on-match element specifies if connection validation should be done when a connection factory attempts to match a managed connection.
    `String` | `validConnectionCheckerClassName()` An org.jboss.jca.adapters.jdbc.ValidConnectionChecker that provides an isValidConnection(Connection) method to validate a connection.
    `T` | `validConnectionCheckerClassName(String value)` An org.jboss.jca.adapters.jdbc.ValidConnectionChecker that provides an isValidConnection(Connection) method to validate a connection.
    `Map` | `validConnectionCheckerProperties()` The valid connection checker properties
    `T` | `validConnectionCheckerProperties(Map value)` The valid connection checker properties
    `T` | `validConnectionCheckerProperty(String key, Object value)` The valid connection checker properties

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Property Detail

    - #### connectionListener

          public Map connectionListenerProperty

      Properties to be injected in class specidied in connection-listener-class

  - ### Constructor Detail

    - #### DataSource

          public DataSource(String key)

  - ### Method Detail

    - #### getKey

          public String getKey()

    - #### addPropertyChangeListener

          public void addPropertyChangeListener(PropertyChangeListener listener)

      Adds a property change listener

    - #### removePropertyChangeListener

          public void removePropertyChangeListener(PropertyChangeListener listener)

      Removes a property change listener

    - #### subresources

          public DataSource.DataSourceResources subresources()

    - #### connectionProperties

          public T connectionProperties(List<ConnectionProperties> value)

      Add all ConnectionProperties objects to this subresource
      Parameters:
        `value` - List of ConnectionProperties objects.
      Returns:
        this

    - #### connectionProperties

          public T connectionProperties(ConnectionProperties value)

      Add the ConnectionProperties object to the list of subresources
      Parameters:
        `value` - The ConnectionProperties to add
      Returns:
        this

    - #### connectionProperties

          public T connectionProperties(String childKey,
                                        ConnectionPropertiesConsumer consumer)

      Create and configure a ConnectionProperties object to the list of subresources
      Parameters:
        `key` - The key for the ConnectionProperties resource
        `config` - The ConnectionPropertiesConsumer to use
      Returns:
        this

    - #### connectionProperties

          public T connectionProperties(String childKey)

      Create and configure a ConnectionProperties object to the list of subresources
      Parameters:
        `key` - The key for the ConnectionProperties resource
      Returns:
        this

    - #### connectionProperties

          public T connectionProperties(ConnectionPropertiesSupplier supplier)

      Install a supplied ConnectionProperties object to the list of subresources

    - #### allocationRetry

          public Integer allocationRetry()

      The allocation retry element indicates the number of times that allocating a connection should be tried before throwing an exception

    - #### allocationRetry

          public T allocationRetry(Integer value)

      The allocation retry element indicates the number of times that allocating a connection should be tried before throwing an exception

    - #### allocationRetryWaitMillis

          public Long allocationRetryWaitMillis()

      The allocation retry wait millis element specifies the amount of time, in milliseconds, to wait between retrying to allocate a connection

    - #### allocationRetryWaitMillis

          public T allocationRetryWaitMillis(Long value)

      The allocation retry wait millis element specifies the amount of time, in milliseconds, to wait between retrying to allocate a connection

    - #### allowMultipleUsers

          public Boolean allowMultipleUsers()

      Specifies if multiple users will access the datasource through the getConnection(user, password) method and hence if the internal pool type should account for that

    - #### allowMultipleUsers

          public T allowMultipleUsers(Boolean value)

      Specifies if multiple users will access the datasource through the getConnection(user, password) method and hence if the internal pool type should account for that

    - #### authenticationContext

          public String authenticationContext()

      The Elytron authentication context which defines the javax.security.auth.Subject that is used to distinguish connections in the pool.

    - #### authenticationContext

          public T authenticationContext(String value)

      The Elytron authentication context which defines the javax.security.auth.Subject that is used to distinguish connections in the pool.

    - #### backgroundValidation

          public Boolean backgroundValidation()

      An element to specify that connections should be validated on a background thread versus being validated prior to use. Changing this value can be done only on disabled datasource, requires a server restart otherwise.

    - #### backgroundValidation

          public T backgroundValidation(Boolean value)

      An element to specify that connections should be validated on a background thread versus being validated prior to use. Changing this value can be done only on disabled datasource, requires a server restart otherwise.

    - #### backgroundValidationMillis

          public Long backgroundValidationMillis()

      The background-validation-millis element specifies the amount of time, in milliseconds, that background validation will run. Changing this value can be done only on disabled datasource, requires a server restart otherwise

    - #### backgroundValidationMillis

          public T backgroundValidationMillis(Long value)

      The background-validation-millis element specifies the amount of time, in milliseconds, that background validation will run. Changing this value can be done only on disabled datasource, requires a server restart otherwise

    - #### blockingTimeoutWaitMillis

          public Long blockingTimeoutWaitMillis()

      The blocking-timeout-millis element specifies the maximum time, in milliseconds, to block while waiting for a connection before throwing an exception. Note that this blocks only while waiting for locking a connection, and will never throw an exception if creating a new connection takes an inordinately long time

    - #### blockingTimeoutWaitMillis

          public T blockingTimeoutWaitMillis(Long value)

      The blocking-timeout-millis element specifies the maximum time, in milliseconds, to block while waiting for a connection before throwing an exception. Note that this blocks only while waiting for locking a connection, and will never throw an exception if creating a new connection takes an inordinately long time

    - #### capacityDecrementerClass

          public String capacityDecrementerClass()

      Class defining the policy for decrementing connections in the pool

    - #### capacityDecrementerClass

          public T capacityDecrementerClass(String value)

      Class defining the policy for decrementing connections in the pool

    - #### capacityDecrementerProperties

          public Map capacityDecrementerProperties()

      Properties to be injected in class defining the policy for decrementing connections in the pool

    - #### capacityDecrementerProperties

          public T capacityDecrementerProperties(Map value)

      Properties to be injected in class defining the policy for decrementing connections in the pool

    - #### capacityDecrementerProperty

          public T capacityDecrementerProperty(String key,
                                               Object value)

      Properties to be injected in class defining the policy for decrementing connections in the pool

    - #### capacityIncrementerClass

          public String capacityIncrementerClass()

      Class defining the policy for incrementing connections in the pool

    - #### capacityIncrementerClass

          public T capacityIncrementerClass(String value)

      Class defining the policy for incrementing connections in the pool

    - #### capacityIncrementerProperties

          public Map capacityIncrementerProperties()

      Properties to be injected in class defining the policy for incrementing connections in the pool

    - #### capacityIncrementerProperties

          public T capacityIncrementerProperties(Map value)

      Properties to be injected in class defining the policy for incrementing connections in the pool

    - #### capacityIncrementerProperty

          public T capacityIncrementerProperty(String key,
                                               Object value)

      Properties to be injected in class defining the policy for incrementing connections in the pool

    - #### checkValidConnectionSql

          public String checkValidConnectionSql()

      Specify an SQL statement to check validity of a pool connection. This may be called when managed connection is obtained from the pool

    - #### checkValidConnectionSql

          public T checkValidConnectionSql(String value)

      Specify an SQL statement to check validity of a pool connection. This may be called when managed connection is obtained from the pool

    - #### connectable

          public Boolean connectable()

      Enable the use of CMR. This feature means that a local resource can reliably participate in an XA transaction.

    - #### connectable

          public T connectable(Boolean value)

      Enable the use of CMR. This feature means that a local resource can reliably participate in an XA transaction.

    - #### connectionListenerClass

          public String connectionListenerClass()

      Speciefies class name extending org.jboss.jca.adapters.jdbc.spi.listener.ConnectionListener that provides a possible to listen for connection activation and passivation in order to perform actions before the connection is returned to the application or returned to the pool.

    - #### connectionListenerClass

          public T connectionListenerClass(String value)

      Speciefies class name extending org.jboss.jca.adapters.jdbc.spi.listener.ConnectionListener that provides a possible to listen for connection activation and passivation in order to perform actions before the connection is returned to the application or returned to the pool.

    - #### connectionListenerProperty

          public Map connectionListenerProperty()

      Properties to be injected in class specidied in connection-listener-class

    - #### connectionListenerProperty

          public T connectionListenerProperty(Map value)

      Properties to be injected in class specidied in connection-listener-class

    - #### connectionListenerProperty

          public T connectionListenerProperty(String key,
                                              Object value)

      Properties to be injected in class specidied in connection-listener-class

    - #### connectionUrl

          public String connectionUrl()

      The JDBC driver connection URL

    - #### connectionUrl

          public T connectionUrl(String value)

      The JDBC driver connection URL

    - #### credentialReference

          public Map credentialReference()

      Credential (from Credential Store) to authenticate on data source

    - #### credentialReference

          public T credentialReference(Map value)

      Credential (from Credential Store) to authenticate on data source

    - #### credentialReference

          public T credentialReference(String key,
                                       Object value)

      Credential (from Credential Store) to authenticate on data source

    - #### datasourceClass

          public String datasourceClass()

      The fully qualified name of the JDBC datasource class

    - #### datasourceClass

          public T datasourceClass(String value)

      The fully qualified name of the JDBC datasource class

    - #### driverClass

          public String driverClass()

      The fully qualified name of the JDBC driver class

    - #### driverClass

          public T driverClass(String value)

      The fully qualified name of the JDBC driver class

    - #### driverName

          public String driverName()

      Defines the JDBC driver the datasource should use. It is a symbolic name matching the the name of installed driver. In case the driver is deployed as jar, the name is the name of deployment unit

    - #### driverName

          public T driverName(String value)

      Defines the JDBC driver the datasource should use. It is a symbolic name matching the the name of installed driver. In case the driver is deployed as jar, the name is the name of deployment unit

    - #### elytronEnabled

          public Boolean elytronEnabled()

      Enables Elytron security for handling authentication of connections. The Elytron authentication-context to be used will be current context if no context is specified (see authentication-context).

    - #### elytronEnabled

          public T elytronEnabled(Boolean value)

      Enables Elytron security for handling authentication of connections. The Elytron authentication-context to be used will be current context if no context is specified (see authentication-context).

    - #### enlistmentTrace

          public Boolean enlistmentTrace()

      Defines if WildFly/IronJacamar should record enlistment traces

    - #### enlistmentTrace

          public T enlistmentTrace(Boolean value)

      Defines if WildFly/IronJacamar should record enlistment traces

    - #### exceptionSorterClassName

          public String exceptionSorterClassName()

      An org.jboss.jca.adapters.jdbc.ExceptionSorter that provides an isExceptionFatal(SQLException) method to validate if an exception should broadcast an error

    - #### exceptionSorterClassName

          public T exceptionSorterClassName(String value)

      An org.jboss.jca.adapters.jdbc.ExceptionSorter that provides an isExceptionFatal(SQLException) method to validate if an exception should broadcast an error

    - #### exceptionSorterProperties

          public Map exceptionSorterProperties()

      The exception sorter properties

    - #### exceptionSorterProperties

          public T exceptionSorterProperties(Map value)

      The exception sorter properties

    - #### exceptionSorterProperty

          public T exceptionSorterProperty(String key,
                                           Object value)

      The exception sorter properties

    - #### flushStrategy

          public FlushStrategy flushStrategy()

      Specifies how the pool should be flush in case of an error.

    - #### flushStrategy

          public T flushStrategy(FlushStrategy value)

      Specifies how the pool should be flush in case of an error.

    - #### idleTimeoutMinutes

          public Long idleTimeoutMinutes()

      The idle-timeout-minutes elements specifies the maximum time, in minutes, a connection may be idle before being closed. The actual maximum time depends also on the IdleRemover scan time, which is half of the smallest idle-timeout-minutes value of any pool. Changing this value can be done only on disabled datasource, requires a server restart otherwise.

    - #### idleTimeoutMinutes

          public T idleTimeoutMinutes(Long value)

      The idle-timeout-minutes elements specifies the maximum time, in minutes, a connection may be idle before being closed. The actual maximum time depends also on the IdleRemover scan time, which is half of the smallest idle-timeout-minutes value of any pool. Changing this value can be done only on disabled datasource, requires a server restart otherwise.

    - #### initialPoolSize

          public Integer initialPoolSize()

      The initial-pool-size element indicates the initial number of connections a pool should hold.

    - #### initialPoolSize

          public T initialPoolSize(Integer value)

      The initial-pool-size element indicates the initial number of connections a pool should hold.

    - #### jndiName

          public String jndiName()

      Specifies the JNDI name for the datasource

    - #### jndiName

          public T jndiName(String value)

      Specifies the JNDI name for the datasource

    - #### jta

          public Boolean jta()

      Enable JTA integration

    - #### jta

          public T jta(Boolean value)

      Enable JTA integration

    - #### maxPoolSize

          public Integer maxPoolSize()

      The max-pool-size element specifies the maximum number of connections for a pool. No more connections will be created in each sub-pool

    - #### maxPoolSize

          public T maxPoolSize(Integer value)

      The max-pool-size element specifies the maximum number of connections for a pool. No more connections will be created in each sub-pool

    - #### mcp

          public String mcp()

      Defines the ManagedConnectionPool implementation, f.ex. org.jboss.jca.core .connectionmanager.pool.mcp.SemaphoreArrayListManagedConnectionPool

    - #### mcp

          public T mcp(String value)

      Defines the ManagedConnectionPool implementation, f.ex. org.jboss.jca.core .connectionmanager.pool.mcp.SemaphoreArrayListManagedConnectionPool

    - #### minPoolSize

          public Integer minPoolSize()

      The min-pool-size element specifies the minimum number of connections for a pool

    - #### minPoolSize

          public T minPoolSize(Integer value)

      The min-pool-size element specifies the minimum number of connections for a pool

    - #### newConnectionSql

          public String newConnectionSql()

      Specifies an SQL statement to execute whenever a connection is added to the connection pool

    - #### newConnectionSql

          public T newConnectionSql(String value)

      Specifies an SQL statement to execute whenever a connection is added to the connection pool

    - #### password

          public String password()

      Specifies the password used when creating a new connection

    - #### password

          public T password(String value)

      Specifies the password used when creating a new connection

    - #### poolFair

          public Boolean poolFair()

      Defines if pool use should be fair

    - #### poolFair

          public T poolFair(Boolean value)

      Defines if pool use should be fair

    - #### poolPrefill

          public Boolean poolPrefill()

      Should the pool be prefilled. Changing this value can be done only on disabled datasource, requires a server restart otherwise.

    - #### poolPrefill

          public T poolPrefill(Boolean value)

      Should the pool be prefilled. Changing this value can be done only on disabled datasource, requires a server restart otherwise.

    - #### poolUseStrictMin

          public Boolean poolUseStrictMin()

      Specifies if the min-pool-size should be considered strictly

    - #### poolUseStrictMin

          public T poolUseStrictMin(Boolean value)

      Specifies if the min-pool-size should be considered strictly

    - #### preparedStatementsCacheSize

          public Long preparedStatementsCacheSize()

      The number of prepared statements per connection in an LRU cache

    - #### preparedStatementsCacheSize

          public T preparedStatementsCacheSize(Long value)

      The number of prepared statements per connection in an LRU cache

    - #### queryTimeout

          public Long queryTimeout()

      Any configured query timeout in seconds. If not provided no timeout will be set

    - #### queryTimeout

          public T queryTimeout(Long value)

      Any configured query timeout in seconds. If not provided no timeout will be set

    - #### reauthPluginClassName

          public String reauthPluginClassName()

      The fully qualified class name of the reauthentication plugin implementation

    - #### reauthPluginClassName

          public T reauthPluginClassName(String value)

      The fully qualified class name of the reauthentication plugin implementation

    - #### reauthPluginProperties

          public Map reauthPluginProperties()

      The properties for the reauthentication plugin

    - #### reauthPluginProperties

          public T reauthPluginProperties(Map value)

      The properties for the reauthentication plugin

    - #### reauthPluginProperty

          public T reauthPluginProperty(String key,
                                        Object value)

      The properties for the reauthentication plugin

    - #### securityDomain

          public String securityDomain()

      Specifies the PicketBox security domain which defines the PicketBox javax.security.auth.Subject that are used to distinguish connections in the pool

    - #### securityDomain

          public T securityDomain(String value)

      Specifies the PicketBox security domain which defines the PicketBox javax.security.auth.Subject that are used to distinguish connections in the pool

    - #### setTxQueryTimeout

          public Boolean setTxQueryTimeout()

      Whether to set the query timeout based on the time remaining until transaction timeout. Any configured query timeout will be used if there is no transaction

    - #### setTxQueryTimeout

          public T setTxQueryTimeout(Boolean value)

      Whether to set the query timeout based on the time remaining until transaction timeout. Any configured query timeout will be used if there is no transaction

    - #### sharePreparedStatements

          public Boolean sharePreparedStatements()

      Whether to share prepared statements, i.e. whether asking for same statement twice without closing uses the same underlying prepared statement

    - #### sharePreparedStatements

          public T sharePreparedStatements(Boolean value)

      Whether to share prepared statements, i.e. whether asking for same statement twice without closing uses the same underlying prepared statement

    - #### spy

          public Boolean spy()

      Enable spying of SQL statements

    - #### spy

          public T spy(Boolean value)

      Enable spying of SQL statements

    - #### staleConnectionCheckerClassName

          public String staleConnectionCheckerClassName()

      An org.jboss.jca.adapters.jdbc.StaleConnectionChecker that provides an isStaleConnection(SQLException) method which if it returns true will wrap the exception in an org.jboss.jca.adapters.jdbc.StaleConnectionException

    - #### staleConnectionCheckerClassName

          public T staleConnectionCheckerClassName(String value)

      An org.jboss.jca.adapters.jdbc.StaleConnectionChecker that provides an isStaleConnection(SQLException) method which if it returns true will wrap the exception in an org.jboss.jca.adapters.jdbc.StaleConnectionException

    - #### staleConnectionCheckerProperties

          public Map staleConnectionCheckerProperties()

      The stale connection checker properties

    - #### staleConnectionCheckerProperties

          public T staleConnectionCheckerProperties(Map value)

      The stale connection checker properties

    - #### staleConnectionCheckerProperty

          public T staleConnectionCheckerProperty(String key,
                                                  Object value)

      The stale connection checker properties

    - #### statisticsEnabled

          public Boolean statisticsEnabled()

      Define whether runtime statistics are enabled or not.

    - #### statisticsEnabled

          public T statisticsEnabled(Boolean value)

      Define whether runtime statistics are enabled or not.

    - #### trackStatements

          public String trackStatements()

      Whether to check for unclosed statements when a connection is returned to the pool, result sets are closed, a statement is closed or return to the prepared statement cache. Valid values are: "false" - do not track statements, "true" - track statements and result sets and warn when they are not closed, "nowarn" - track statements but do not warn about them being unclosed

    - #### trackStatements

          public T trackStatements(String value)

      Whether to check for unclosed statements when a connection is returned to the pool, result sets are closed, a statement is closed or return to the prepared statement cache. Valid values are: "false" - do not track statements, "true" - track statements and result sets and warn when they are not closed, "nowarn" - track statements but do not warn about them being unclosed

    - #### tracking

          public Boolean tracking()

      Defines if IronJacamar should track connection handles across transaction boundaries

    - #### tracking

          public T tracking(Boolean value)

      Defines if IronJacamar should track connection handles across transaction boundaries

    - #### transactionIsolation

          public String transactionIsolation()

      Set the java.sql.Connection transaction isolation level. Valid values are: TRANSACTION_READ_UNCOMMITTED, TRANSACTION_READ_COMMITTED, TRANSACTION_REPEATABLE_READ, TRANSACTION_SERIALIZABLE and TRANSACTION_NONE. Different values are used to set customLevel using TransactionIsolation#customLevel

    - #### transactionIsolation

          public T transactionIsolation(String value)

      Set the java.sql.Connection transaction isolation level. Valid values are: TRANSACTION_READ_UNCOMMITTED, TRANSACTION_READ_COMMITTED, TRANSACTION_REPEATABLE_READ, TRANSACTION_SERIALIZABLE and TRANSACTION_NONE. Different values are used to set customLevel using TransactionIsolation#customLevel

    - #### urlDelimiter

          public String urlDelimiter()

      Specifies the delimiter for URLs in connection-url for HA datasources

    - #### urlDelimiter

          public T urlDelimiter(String value)

      Specifies the delimiter for URLs in connection-url for HA datasources

    - #### urlSelectorStrategyClassName

          public String urlSelectorStrategyClassName()

      A class that implements org.jboss.jca.adapters.jdbc.URLSelectorStrategy

    - #### urlSelectorStrategyClassName

          public T urlSelectorStrategyClassName(String value)

      A class that implements org.jboss.jca.adapters.jdbc.URLSelectorStrategy

    - #### useCcm

          public Boolean useCcm()

      Enable the use of a cached connection manager

    - #### useCcm

          public T useCcm(Boolean value)

      Enable the use of a cached connection manager

    - #### useFastFail

          public Boolean useFastFail()

      Whether to fail a connection allocation on the first try if it is invalid (true) or keep trying until the pool is exhausted of all potential connections (false)

    - #### useFastFail

          public T useFastFail(Boolean value)

      Whether to fail a connection allocation on the first try if it is invalid (true) or keep trying until the pool is exhausted of all potential connections (false)

    - #### useJavaContext

          public Boolean useJavaContext()

      Setting this to false will bind the datasource into global JNDI

    - #### useJavaContext

          public T useJavaContext(Boolean value)

      Setting this to false will bind the datasource into global JNDI

    - #### useTryLock

          public Long useTryLock()

      Any configured timeout for internal locks on the resource adapter objects in seconds

    - #### useTryLock

          public T useTryLock(Long value)

      Any configured timeout for internal locks on the resource adapter objects in seconds

    - #### userName

          public String userName()

      Specify the user name used when creating a new connection

    - #### userName

          public T userName(String value)

      Specify the user name used when creating a new connection

    - #### validConnectionCheckerClassName

          public String validConnectionCheckerClassName()

      An org.jboss.jca.adapters.jdbc.ValidConnectionChecker that provides an isValidConnection(Connection) method to validate a connection. If an exception is returned that means the connection is invalid. This overrides the check-valid-connection-sql element

    - #### validConnectionCheckerClassName

          public T validConnectionCheckerClassName(String value)

      An org.jboss.jca.adapters.jdbc.ValidConnectionChecker that provides an isValidConnection(Connection) method to validate a connection. If an exception is returned that means the connection is invalid. This overrides the check-valid-connection-sql element

    - #### validConnectionCheckerProperties

          public Map validConnectionCheckerProperties()

      The valid connection checker properties

    - #### validConnectionCheckerProperties

          public T validConnectionCheckerProperties(Map value)

      The valid connection checker properties

    - #### validConnectionCheckerProperty

          public T validConnectionCheckerProperty(String key,
                                                  Object value)

      The valid connection checker properties

    - #### validateOnMatch

          public Boolean validateOnMatch()

      The validate-on-match element specifies if connection validation should be done when a connection factory attempts to match a managed connection. This is typically exclusive to the use of background validation

    - #### validateOnMatch

          public T validateOnMatch(Boolean value)

      The validate-on-match element specifies if connection validation should be done when a connection factory attempts to match a managed connection. This is typically exclusive to the use of background validation

Copyright © 2017 JBoss by Red Hat. All rights reserved.